"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAddSchematic = void 0;
const schematics_1 = require("@angular-devkit/schematics");
const workspace_1 = require("@schematics/angular/utility/workspace");
const path = require("path");
const utils_1 = require("../../utils/utils");
function createAddSchematic(options) {
    return (host) => __awaiter(this, void 0, void 0, function* () {
        const workspace = yield workspace_1.getWorkspace(host);
        const project = yield utils_1.getProject(workspace, options.project);
        const parsedPath = utils_1.getParsedPath(project, options.path, 'ng-add');
        const templateSource = schematics_1.apply(schematics_1.url('./files'), [schematics_1.applyTemplates({}), schematics_1.move(parsedPath.path)]);
        return schematics_1.chain([schematics_1.mergeWith(templateSource), updateCollectionJson(host, project, parsedPath.path, options)]);
    });
}
exports.createAddSchematic = createAddSchematic;
function updateCollectionJson(host, project, pathToSchematic, options) {
    const collectionPath = utils_1.getCollectionPath(host, project);
    const collectionJsonBuffer = host.read(collectionPath);
    if (!collectionJsonBuffer) {
        throw new schematics_1.SchematicsException(`Could not read file '${collectionPath}'`);
    }
    const collectionJson = JSON.parse(collectionJsonBuffer.toString('utf8'));
    const relativePathToSchematic = path
        .relative(path.join(process.cwd(), path.dirname(collectionPath)), path.join(process.cwd(), pathToSchematic, 'ng-add', 'index'))
        .replace(/\\/g, '/');
    const updatedCollectionJson = Object.assign(Object.assign({}, collectionJson), { schematics: Object.assign({ 'ng-add': {
                save: options.saveAs,
                description: 'Bootstrap package',
                factory: `${relativePathToSchematic}#ngAdd`,
            } }, collectionJson.schematics) });
    host.overwrite(collectionPath, JSON.stringify(updatedCollectionJson, null, 2));
    return schematics_1.noop();
}
//# sourceMappingURL=index.js.map