"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getProject = exports.getCollectionPath = exports.getParsedPath = void 0;
const schematics_1 = require("@angular-devkit/schematics");
const path = require("path");
const workspace_1 = require("@schematics/angular/utility/workspace");
const parse_name_1 = require("@schematics/angular/utility/parse-name");
function getParsedPath(project, path, dirName) {
    if (path === undefined && project) {
        path = workspace_1.buildDefaultPath(project);
    }
    return parse_name_1.parseName(path, dirName);
}
exports.getParsedPath = getParsedPath;
function getCollectionPath(host, project) {
    const packageJsonPath = path.join(project.root, 'package.json');
    const packageJsonBuffer = host.read(packageJsonPath);
    if (!packageJsonBuffer) {
        throw new schematics_1.SchematicsException(`Could not read file '${packageJsonPath}'`);
    }
    const packageJson = JSON.parse(packageJsonBuffer.toString('utf8'));
    return path.join(project.root, packageJson.schematics);
}
exports.getCollectionPath = getCollectionPath;
function getProject(workspace, projectName) {
    return __awaiter(this, void 0, void 0, function* () {
        if (workspace.projects.has(projectName)) {
            return workspace.projects.get(projectName);
        }
        else {
            throw new schematics_1.SchematicsException(`A project with the name '${projectName}' does not exists`);
        }
    });
}
exports.getProject = getProject;
//# sourceMappingURL=utils.js.map